//+-----------------------------------------------------------------------------------------------------------------------------+
//| CLASS:				CLibNewBar.mqh
//+-----------------------------------------------------------------------------------------------------------------------------+
class CLibNewBar {

public:
		CLibNewBar() {  }
		CLibNewBar(string pSymbol);
	 ~CLibNewBar() {	}

private:
		string								mSymbol;																// SET WHEN INITIALIZE CLASS
		ENUM_TIMEFRAMES				mTimeFrame;															// SET WHILE USING IN DERIVED CLASS TO SET ITS PARAMETERS

		datetime							mPrevTimeD01;
		datetime							mPrevTimeH01;
		datetime							mPrevTimeM15;
		datetime							mPrevTimeM05;
		datetime							mPrevTimeM01;

public:
		bool									D01();
		bool									H01();
		bool									M15();
		bool									M05();
		bool									M01();

}; // END Of Class Definition
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:				CLibNewBar()
//| APPLICATION:	PARAMETRIC CONSTRUCTOR
//+-----------------------------------------------------------------------------------------------------------------------------+
CLibNewBar::CLibNewBar(string pSymbol) {

		mSymbol 			 = pSymbol;
		mPrevTimeD01	 = WRONG_VALUE;
		mPrevTimeH01	 = WRONG_VALUE;
		mPrevTimeM15	 = WRONG_VALUE;
		mPrevTimeM01	 = WRONG_VALUE;
		mPrevTimeM01	 = WRONG_VALUE;

} // END Of method CLibNewBar()
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:      D01()
//+-----------------------------------------------------------------------------------------------------------------------------+
bool CLibNewBar::D01() {

  datetime vCurrTime = (datetime)SeriesInfoInteger(mSymbol,PERIOD_D1,SERIES_LASTBAR_DATE);
  if(mPrevTimeD01 != vCurrTime) 																										{	mPrevTimeD01 = vCurrTime;	return(true);	}
  return(false);

} // End of method D01()
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:      H01()
//+-----------------------------------------------------------------------------------------------------------------------------+
bool CLibNewBar::H01() {

  datetime vCurrTime = (datetime)SeriesInfoInteger(mSymbol,PERIOD_H1,SERIES_LASTBAR_DATE);
  if(mPrevTimeH01 != vCurrTime) 																										{	mPrevTimeH01 = vCurrTime;	return(true);	}
  return(false);

} // End of method H01()
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:      M15()
//+-----------------------------------------------------------------------------------------------------------------------------+
bool CLibNewBar::M15() {

  datetime vCurrTime = (datetime)SeriesInfoInteger(mSymbol,PERIOD_M15,SERIES_LASTBAR_DATE);
  if(mPrevTimeM15 != vCurrTime) 																										{	mPrevTimeM15 = vCurrTime;	return(true);	}
  return(false);

} // End of method M15()
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:      M05()
//+-----------------------------------------------------------------------------------------------------------------------------+
bool CLibNewBar::M05() {

  datetime vCurrTime = (datetime)SeriesInfoInteger(mSymbol,PERIOD_M5,SERIES_LASTBAR_DATE);
  if(mPrevTimeM05 != vCurrTime) 																										{	mPrevTimeM05 = vCurrTime;	return(true);	}
  return(false);

} // End of method M05()
//+-----------------------------------------------------------------------------------------------------------------------------+
//| METHOD:      M01()
//+-----------------------------------------------------------------------------------------------------------------------------+
bool CLibNewBar::M01() {

  datetime vCurrTime = (datetime)SeriesInfoInteger(mSymbol,PERIOD_M1,SERIES_LASTBAR_DATE);
  if(mPrevTimeM01 != vCurrTime) 																										{	mPrevTimeM01 = vCurrTime;	return(true);	}
  return(false);

} // End of method M01()
//+-----------------------------------------------------------------------------------------------------------------------------+
